package htLuokat;

import java.io.OutputStream;
import java.io.PrintStream;

/**
 *  @author Leevi Pohja(pohjalma@jyu.fi), Jaakko Juvonen(jtjuvone@jyu.fi)
 *  ,Jaakko Jokisalo(jjjokisa@student.jyu.fi)
 * @version 2 Mar 2022
 *
 */
public class Huone {
    private int id;  
    private String nimi = ""; 
    private static int seuraavaNro = 1;

    
    /**
     * Huoneen nimi muodostaja
     * @param nimi huoneen nimi
     */
    public Huone(String nimi) {
        this.nimi = nimi;
    }
    
    
    /**
     * luo huone olion
     * @param nimi huoneen nimi
     * @param id id;
     */
    public Huone(String nimi, int id) {
        this.nimi = nimi;
        this.id = id;
        seuraavaNro++;
    }
    
    
    /**
     * rekisteröi uuden huoneen
     * @return huoneen id numero
     * @example
     * <pre name="test">
     * Huone h = new Huone("vessa");
     * h.rekisteroi();
     * h.getId()=== 1;
     * Huone h1 = new Huone("keittio");
     * h1.rekisteroi();
     * h1.getId()=== 2;
     * </pre>
     */
    public int rekisteroi() {
        this.id = seuraavaNro;
        seuraavaNro++;
        return this.id;
    }
    
    
    /**
     * @return palauttaa id:n
     */
    public int getId() {
        return id;
    }
    
    
    /**
     * metodi jolla saadaan tulostettua olion nimi
     */
    @Override
    public String toString() {
        return nimi;
    }
    
    
    /**
     * @return palauttaa nimen
     */
    public String getNimi() {
        return nimi;
    }
    
    
    /**
     * tulostaa tiedot
     * @param out tietovirta 
     */
    public void tulosta(PrintStream out) {
        out.println(nimi + ", ID: " + id);
    }
    
    
    /**
     * 
     * Asettaa huoneelle nimen
     * @param nimi Huoneen nimi
     */
    public void setNimi(String nimi) {
        this.nimi = nimi;
    }
    
    
    /**
     * tulostaa huoneen tiedot
     * @param os tietovirta
     */
    public void tulosta(OutputStream os) {
        tulosta(new PrintStream(os));
    }
    
    
    /**
     * @param args ei kaytossa 
     */
    public static void main(String [] args) {
        
        Huone keittio = new Huone("keittio");
        keittio.rekisteroi();
        keittio.tulosta(System.out);
        
        Huone vessa = new Huone("vessa");
        vessa.rekisteroi();
        vessa.tulosta(System.out);          
    }  
}
