package htLuokat;

import java.io.OutputStream;
import java.io.PrintStream;

/**
 *  @author Leevi Pohja(pohjalma@jyu.fi), Jaakko Juvonen(jtjuvone@jyu.fi)
 *  , Jaakko Jokisalo(jjjokisa@student.jyu.fi)
 * @version 2 Mar 2022
 *
 */
public class Kayttaja {

    
    private int id;
    private String nimi;
    private static int seuraavaNro = 1;
    
    
    /**
     * 
     */
    public Kayttaja() {
     
    }
    
    
    /**
     * Muodostaja
     * @param nimi käyttäjän nimi
     * 
     */
    public Kayttaja(String nimi) {
     this.nimi = nimi;
    }
    
    
    /**
     * Kaytetaan tata kun luetaan tiedostosta
     * @param nimi nimi
     * @param id id
     */
    public Kayttaja(String nimi, int id) {
     this.nimi = nimi;
     this.id = id;
     seuraavaNro++;
    }
    
    
    /**
     * @param args ei käytössä
     */
    public static void main(String[] args) {
        Kayttaja juvonen = new Kayttaja();
        Kayttaja jokisalo = new Kayttaja();
        Kayttaja pohja = new Kayttaja();

        
        juvonen.rekisteroi();
        jokisalo.rekisteroi();
        pohja.rekisteroi();
        
        
        juvonen.tayta();
        juvonen.tulosta(System.out);
        pohja.tayta();
        pohja.tulosta(System.out);
        jokisalo.tayta();
        jokisalo.tulosta(System.out);  
    }
    

    /**
     * Tulostaa käyttäjän tiedot
     * @param out tietovirta 
     */
    public void tulosta(PrintStream out) {
        out.println(nimi + ", ID: " + id);
    }
    
    
    /**
     * Tulostaa henkilön tiedot
     * @param os tietovirta
     */
    public void tulosta(OutputStream os) {
        tulosta(new PrintStream(os));
    }
    
    
    /**
     * toString metodi
     * @example
     * <pre name="test">
     * Kayttaja uusi = new Kayttaja("ville");
     * String t = uusi.toString();
     * t === "ville"; 
     * </pre>
     */
    @Override
    public String toString() {
        return nimi;
    }
    
    
    /**
     * Rekisteröi uuden kayttäjän
     * @return käyttäjän id numero
     * @example
     * <pre name="test">
     * Kayttaja uusi = new Kayttaja();
     * uusi.rekisteroi();
     * uusi.getId() === 1;
     * Kayttaja uusi1 = new Kayttaja();
     * uusi1.rekisteroi();
     * uusi1.getId() === 2;
     * Kayttaja uusi3 = new Kayttaja();
     * uusi3.rekisteroi();
     * uusi3.getId() === 3;
     * </pre>
     */
    public int rekisteroi() {
        this.id = seuraavaNro;
        seuraavaNro++;
        return this.id;
    }
    
    
    /**
     * Täytetään käytäjän tiedot
     */
    public void tayta() {
        nimi = "Meikä Mandoliini"; 
    }
    
    
    /**
     * Palauttaa nimen
     * @return nimi
     * 
     */
    public String getNimi() {
        return nimi;
    }
    
    
    /**
     * Palauttaa id:n
     * @return id 
     */
    public int getId() {
        return this.id;
    }
    
    
    /**
     * Asetetaan kayttajalle nimi
     * @param nimi asetettava nimi
     */
    public void setNimi(String nimi) {
        this.nimi = nimi;
    }  
}
