package htLuokat;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.PrintStream;
import java.util.Scanner;

import fi.jyu.mit.ohj2.Mjonot;

/**
 *  @author Leevi Pohja(pohjalma@jyu.fi), Jaakko Juvonen(jtjuvone@jyu.fi)
 *  , Jaakko Jokisalo(jjjokisa@student.jyu.fi)
 * @version 2 Mar 2022
 *
 */
public class Kayttajat {
    
    private static final int MAX_KAYTTAJAT = 10;
    private Kayttaja[] kayttajat = new Kayttaja[MAX_KAYTTAJAT];
    private int lkm = 0;
    private boolean muutettu = false;
    
    
/**
 *  Luodaaan uusi kayttajat olio
 */
    public Kayttajat() {

    }
    
   
    /**
     * @param args ei käytössä
     * 
     */
    public static void main(String[]args)  {
        
    Kayttajat kayttajat1 = new Kayttajat();
    
        Kayttaja pohja = new Kayttaja("keijjo");     
        Kayttaja juvonen = new Kayttaja("kalle");
        Kayttaja jokisalo = new Kayttaja("ville");
        kayttajat1.lisaa(juvonen);
        kayttajat1.lisaa(pohja);
        kayttajat1.lisaa(jokisalo);
        juvonen.rekisteroi();
        jokisalo.rekisteroi();
        pohja.rekisteroi();
 
        kayttajat1.poista(jokisalo);
        System.out.println(kayttajat1.getlength());
        kayttajat1.poista(pohja);
        System.out.println(kayttajat1.getlength());
        kayttajat1.poista(juvonen);
        System.out.println(kayttajat1.getlength());
        kayttajat1.poista(juvonen);
    }
    
    
    /**
     * @param kayttaja käyttäjä
     * @example
     * <pre name="test">
     * Kayttajat t = new Kayttajat();
     * Kayttaja uusi = new Kayttaja("janne");
     * t.lisaa(uusi);
     * t.haeKayttaja(0).equals(uusi);
     * </pre>
     */
    public void lisaa(Kayttaja kayttaja){
   
        if(lkm >= kayttajat.length) {
            Kayttaja[] kasvatus = new Kayttaja[kayttajat.length * 2];
            for(int i = 0; i < kayttajat.length; i++) {
                kasvatus[i] = kayttajat[i];
            }
            kayttajat = kasvatus;
        }
        kayttajat[lkm] = kayttaja;
        lkm++;
       muutettu = true;
    }
    
    
    /**
     * Palauttaa viitteen jäseneen
     * @param i mones jäsen halutaan
     * @return viite jäseneen
     * @throws IndexOutOfBoundsException jos i ei sallitulla alueella
     */
    public Kayttaja anna(int i) throws IndexOutOfBoundsException {
        if(i < 0 || lkm <= i)
            throw new IndexOutOfBoundsException("Laiton indeksi" + i);
        return kayttajat[i];
    }
    
    
    /**
     * Alustetaan testejä varten kayttajat olio arvoilla;
     * @return kayttajat olion
     */
    public Kayttajat testiAlustus() {
       Kayttajat t = new Kayttajat();
       int i = 0;
       while(i < 10)
       {
           Kayttaja uusi = new Kayttaja();
           uusi.rekisteroi();
           t.lisaa(uusi);
           i++;
       }
    return t;
    }
    
    
    /**
     * @return pituuden
     */
    public int getlength() {
        return lkm;
    }
    
    
    /**
     * poistetaan valittu kayttaja
     * @param poistettava poistettava kayttaja
     * @example
     * <pre name="test">
     * Kayttajat kayttajat1 = new Kayttajat();
     * Kayttaja pohja = new Kayttaja("keijjo");     
     * Kayttaja juvonen = new Kayttaja("kalle");
     * Kayttaja jokisalo = new Kayttaja("ville");
     * kayttajat1.lisaa(juvonen);
     * kayttajat1.lisaa(pohja);
     * kayttajat1.lisaa(jokisalo);
     * juvonen.rekisteroi();
     * jokisalo.rekisteroi();
     * pohja.rekisteroi();
     * kayttajat1.getlength() === 3;
     * kayttajat1.poista(jokisalo);
     * kayttajat1.getlength() === 2;
     * kayttajat1.poista(pohja);
     * kayttajat1.getlength() === 1;
     * kayttajat1.poista(juvonen);
     * kayttajat1.getlength() === 0;
     * kayttajat1.poista(juvonen);
     * kayttajat1.getlength() === 0;
     * </pre>
     */
    public void poista(Kayttaja poistettava) {
        if(poistettava == null) return;
        int id = poistettava.getId();
        int muutos = 0;
        int lkm1 = 0;
        Kayttaja[] uusi = new Kayttaja[kayttajat.length];
        for(int i = 0; i < this.lkm; i++) {
            if(kayttajat[i].getId() != id ) {
                uusi[lkm1++] = kayttajat[i];
            }
            else {
                muutettu = true;
                muutos = 1;
            }
            
        }
        kayttajat = uusi;
        if(muutos == 1)this.lkm = lkm1;
        tallenna();
    }
    
    
    /**
     * Haetaan käyttäjä indeksin paikalta
     * @param paikka paikka josta kayttaja otetaan 
     * @return palauttaa kayttajan
     */
    public Kayttaja haeKayttaja(int paikka) {
        return kayttajat[paikka];
    }
    
    
    /**
     * @param id kayttajan id
     * @return palauttaa kayttajan jolla on haluttu id
     */
    public Kayttaja haekayttajaIdP(int id) {
        for(int i = 0; i< kayttajat.length; i++) {
            if(kayttajat[i].getId() == id) return kayttajat[i];
        }
        return null;
    }
    
    
    /** Nimi vaihdetaan uuteen string jonoon jossa uusi muokattu nimi
     * @param nimi nimi
     * @param u olio 
     */
    public void muokkaaNimea(String nimi, Object u) {
        Kayttaja k = (Kayttaja)u;
        k.setNimi(nimi);
        muutettu = true;
    }


    /**
     * Luetaan tiedostosta kayttajat 
     */
    public void luetiedostosta() {
     String tied = "kayttajat.dat";
     
     try (Scanner fi = new Scanner(new FileInputStream(new File(tied)))) { // Jotta UTF8/ISO-8859 toimii
         while ( fi.hasNext() ) {
             try {
                 String rivi = fi.nextLine();
                 StringBuilder erotus = new StringBuilder();
                 erotus.append(rivi);
                 String nimi = Mjonot.erota(erotus, '|');
                 int id = Mjonot.erotaInt(erotus, -1);
                 Kayttaja uusi = new Kayttaja(nimi, id);
                 
                
                    this.lisaa(uusi);
               
                 
             } catch (NumberFormatException ex) {
                 // Hylätään
             }
         }
     } catch (FileNotFoundException ex) {
         System.err.println("Tiedosto ei aukea! " + ex.getMessage());
         return;
     }
    }
    
    
     /**
     * Tallennetaan kayttajat
     */
    public void tallenna(){
        if(muutettu == false) return;
        
     String tied = "kayttajat.dat";  
     File t = new File(tied);
     t.delete();
     
     try (PrintStream fo = new PrintStream(new FileOutputStream(tied, true))) {
         for(int i = 0; i < this.lkm; i++) {
             if(kayttajat[i] == null && kayttajat[i+1] != null) {
                 kayttajat[i] = kayttajat[i+1];
                 kayttajat[i+1] = null;
                 fo.println(kayttajat[i].getNimi() +"|"+ kayttajat[i].getId());
             }
             else if(kayttajat[i] != null) fo.println(kayttajat[i].getNimi() +"|"+ kayttajat[i].getId());  
         }
       
         } catch (FileNotFoundException ex) {
             System.err.println("Tiedosto ei aukea: " + ex.getMessage());
         }
     muutettu = false;
     }   
 }
    
    
    

