/**
 * 
 */
package htLuokat;

/**
 *  @author Leevi Pohja(pohjalma@jyu.fi), Jaakko Juvonen(jtjuvone@jyu.fi)
 *  , Jaakko Jokisalo(jjjokisa@student.jyu.fi)
 * @version 11 Mar 2022
 *
 */
public class KotityoRekisteri {
    
   private final TehtavaLokit loki = new TehtavaLokit();
   private final Huoneet huoneet  = new Huoneet();
   private final Kayttajat kayttajat  = new Kayttajat();
   private final Tehtavat tehtavat = new Tehtavat();
   private final Liimataulut liimataulu = new Liimataulut();
   
   
/** 
 * @param uusi uusi kayttaja
 * @example
 * <pre name="test">
 *  Kayttajat t = new Kayttajat(); 
 *  Kayttaja uusi = new Kayttaja("muurarirabbi"); 
 *  t.lisaa(uusi); 
 *  t.haeKayttaja(0).equals(uusi); 
 * </pre>
 */
public void lisaaKayttaja(Kayttaja uusi) {
    
    uusi.rekisteroi();
    
        kayttajat.lisaa(uusi);
     
}


/**
 * @param muutos muutettu nimi
 * @param muokattu olio jonka nimeä muokataan 
 * @param mita minkä luokan olio
 */
public void muokkaa(String muutos, Object muokattu, String mita) {
    if(mita== "Kayttaja") kayttajat.muokkaaNimea(muutos, muokattu);
    if(mita== "Huone") huoneet.muokkaaNimea(muutos, muokattu);
    if(mita== "Tehtava") tehtavat.muokkaaNimea(muutos, muokattu);
}


    /**
     * valitetaan tieto poistettavasta eteenpain
     * @param kasiteltava olio joka poistetaan
     * @param luokka mita luokkaa poistettava olio on
     */
    public void poista(Object kasiteltava, int luokka) {
    if(kasiteltava == null) return;
    if(luokka == 1) { 
        Kayttaja poistettava = ((Kayttaja)kasiteltava);
        kayttajat.poista(poistettava);
    loki.paivitaK(poistettava);
    }
    
    if (luokka == 2 ) { 
        Tehtava poistettava = ((Tehtava)kasiteltava);
        tehtavat.poista(poistettava);
        getLoki().paivitaT(poistettava);
        liimataulu.paivitaT(poistettava);
        }
    
    if (luokka == 3 ) {
    Huone poistettava = ((Huone)kasiteltava);
    huoneet.poista(poistettava);
    loki.paivitaH(poistettava);
    liimataulu.paivitaH(poistettava);
    }
   }
    
    
/**
 * @return kayttajien maara
 */
public int kayttajienLkm() {
   return   kayttajat.getlength();
}


/**
 * @param i paikka
 * @return kayttaja
 */
public Kayttaja haeKayttaja(int i) {
    
    return kayttajat.haeKayttaja(i);
}


/**
 * Palauttaa lokin
 * @return loki
 */
public TehtavaLokit getLoki() {
    return this.loki;
}


/**
 * @param suoritus suoritus
 */
public void lisaa(TehtavaLoki suoritus) {
    try {
        loki.lisaa(suoritus);
    } catch (SailoException e) {
        // TODO Auto-generated catch block
        e.printStackTrace();
    }
    
}


/**
 * @param tehtava tehtava
 * @example
 * <pre name="test">
 *  Tehtavat t = new Tehtavat(); 
 *  Tehtava j = new Tehtava("jumalanpalvelus"); 
 *  j.rekisteroi(); 
 *  t.lisaa(j); 
 *    t.getTehtava(0).equals(j); 
 * </pre>
 */
public void lisaaTehtava(Tehtava tehtava) {
  tehtava.rekisteroi();
    tehtavat.lisaa(tehtava);
}


/**
 * @param huone huone
 * @example
 * <pre name="test">
 * Huoneet t = new Huoneet(); 
 *  Huone h = new Huone("kirjasto"); 
 *  h.rekisteroi(); 
 *  t.lisaa(h); 
 *  int i = t.gethuoneetlkm(); 
 *  assertEquals("From: Huoneet line: 58", 1, i); 
 *  t.gethuone(0).equals(t.gethuoneIdP(h.getId())); 
 *  t.lisaa(h); 
 *  t.lisaa(h); 
 *  t.lisaa(h); 
 *  i = t.gethuoneetlkm(); 
 *  assertEquals("From: Huoneet line: 64", 4, i);   
 * </pre>
 */
public void lisaaHuone(Huone huone) {
        huone.rekisteroi();
        
        huoneet.lisaa(huone);
        liimataulu.lisaaTehtavat(huone, tehtavat);
    
    
}
 

    /**
     * @param i indeksi
     * @return palauttaa kayttajan
     */
    public Kayttaja getjasen(int i) {
    return kayttajat.haeKayttaja(i);
    }

    
/**
 * @return huoneet lkm
 */
public int huoneetlkm() {
    return huoneet.gethuoneetlkm();
}


/**
 * @param i indeksi
 * @return huone
 */
public Huone getHuone(int i) {
    return  huoneet.gethuone(i);
}


/**
 * @param i indeksi
 * @return tehtava
 */
public Tehtava getTehtava(int i) {
    // TODO Auto-generated method stub
    return tehtavat.getTehtava(i);
}


/**
 * @return lkm
 */
public int tehtavatlkm() {
    
    return tehtavat.getlkm();
}


    /**
     * @param tied luettavan tiedoston nimi
     */
    public void lue(String tied) {
        if(tied.equals("kayttajat.dat")) kayttajat.luetiedostosta();
        if(tied.equals("huoneet.dat")) huoneet.luetiedostosta();
        if(tied.equals("tehtavat.dat")) tehtavat.luetiedostosta();
        if(tied.equals("tehtavalog.dat")) loki.luetiedostosta(kayttajat, huoneet, tehtavat);
        if(tied.equals("liimataulu.dat")) liimataulu.luetiedostosta();
    }


    /**
     * @param tied tallennetaan 
     */
    public void tallenna(String tied) {
        if(tied.equals("kayttajat.dat")) kayttajat.tallenna();
        if(tied.equals("huoneet.dat")) huoneet.tallenna();
        if(tied.equals("tehtavat.dat")) tehtavat.tallenna();
        if(tied.equals("liimataulu.dat")) liimataulu.tallenna();
        if(tied.equals("tehtavalog.dat")) loki.tallenna();
    }
    
    
    /**
     * poistetaan liimataulusta parametrien perusteella
     * @param hid huone id
     * @param tid tehtävä id
     */
    public void poistaliimataulusta(int hid, int tid) {
        liimataulu.poista(hid, tid);
    }

    
    /**
     * @param idH huoneen id
     * @param idT tehtavan id
     * @return totuusarvo
     */
    public boolean onkoKaytossa(int idH, int idT) {
        
        return liimataulu.onkoKaytossa(idH, idT);
    }

    
    /**
     * @param h huone
     * @param t tehtava
     */
    public void lisaaLiimatauluun(Huone h, Tehtava t) {
        Liimataulu l = new Liimataulu(h.getId(), t.getId());
       liimataulu.lisaa(l); 
    }
    
    
    /**
     * Palauttaa suorituksien lukumäärän
     * @return suoritusten lukumäärän
     */
    public int suorituksienlkm() {
        return loki.getSLkm();
    }
    
    
    /**
     *  Hakee suorituksen indeksin paikalta i
     * @param i indeksin paikka
     * @return Palauttaa haetun suorituksen
     */
    public String[] haeSuoritus(int i) {
        return loki.haeSuoritus(i);
    }
    
    
    /**
     * Hakee tehtävälokin indeksin paikalta i 
     * @param i indeksin paikka
     * @return haetun tehtävälokin
     */
    public TehtavaLoki haeTehtavaLoki(int i) {
        return loki.haeTehtavaLoki(i);
    }
}
