package htLuokat;

import java.io.OutputStream;
import java.io.PrintStream;

/**
 *  @author Leevi Pohja(pohjalma@jyu.fi), Jaakko Juvonen(jtjuvone@jyu.fi)
 *  , Jaakko Jokisalo(jjjokisa@student.jyu.fi)
 * @version 2 Mar 2022
 *
 */


public class Tehtava {
    private int id;  
    private String nimi = ""; 
    private static int seuraavaNro = 1;

    
    /**
     * @param nimi tehtavan nimi
     */
    public Tehtava(String nimi) {
        this.nimi = nimi;
    }
    
    
    /**
     * @param nimi tehtavan nimi
     * @param id id
     */
    public Tehtava(String nimi, int id) {
        this.nimi = nimi;
        this.id = id;
        seuraavaNro++;
    }
    
    
    /**
     * @return nimi
     */
    @Override
    public String toString() {
        return nimi;
    }
    
    
    /**
     * Rekisteröi uuden tehtavan 
     * @return tehtavan id numero
     * @example
     * <pre name="test">
     * Tehtava uusi = new Tehtava("imurointi");
     * uusi.rekisteroi();
     * uusi.getId() === 1;
     * uusi.rekisteroi();
     * uusi.getId() === 2; 
     * </pre>
     */
    public int rekisteroi() {
        this.id = seuraavaNro;
        seuraavaNro++;
        return this.id;
    }
   
    
    /**
     * @return palauttaa id:n
     */
    public int getId() {
        return this.id;
    }
    
    
    /**
     * @return palauttaa nimen
     */
    public String getNimi() {
        return nimi;
    }
    
    
    /**
     * Tulostaa käyttäjän tiedot
     * @param out tietovirta 
     */
    public void tulosta(PrintStream out) {
        out.println(nimi + ", ID: " + id);
    }
    
    
    /**
     * Tulostaa huoneen tiedot
     * @param os tietovirta
     */
    public void tulosta(OutputStream os) {
        tulosta(new PrintStream(os));
    }
    
    
    /**
     * @param args ei kaytossa 
     */
    public static void main(String [] args) {
        
        Tehtava imurointi = new Tehtava("Imurointi");
        imurointi.rekisteroi();
        imurointi.tulosta(System.out);
        
        Tehtava luuttuaminen = new Tehtava("Luuttuaminen");
        luuttuaminen.rekisteroi();
        luuttuaminen.tulosta(System.out);
    }

    
    /**
     * Asettaa nimen
     * @param nimi tehtävän nimi
     */
    public void setNimi(String nimi) {
        this.nimi = nimi;
    }
    
    
    /**
     * Palauttaa tehtävän nimen
     * @return tehtävän nimi
     */
    public String getTehtavaNimi() {
        
        return this.nimi;
    }
}
