package htLuokat;

import java.io.PrintStream;
import java.text.SimpleDateFormat;
import java.util.Date;

/**
 *  @author Leevi Pohja(pohjalma@jyu.fi), Jaakko Juvonen(jtjuvone@jyu.fi)
 *  , Jaakko Jokisalo(jjjokisa@student.jyu.fi)
 * @version 2 Mar 2022
 *
 */


public class TehtavaLoki {
    
    private String kellonaika;
    private Kayttaja kayttaja;
    private Huone huone;
    private Tehtava tehtava;
   int tehtavalkm = 0;
    
   
    /**
     * @return aika
     */
    public static String getTime() {
        Date aika = new Date(System.currentTimeMillis());
        SimpleDateFormat formatter= new SimpleDateFormat("yyyy-MM-dd 'klo' HH:mm:ss");
        return formatter.format(aika);
    }
    
    @Override
    public String toString() {
        String s = kellonaika + " " + kayttaja.getNimi().toString()+ " " + huone.getNimi().toString() + " "+ tehtava.getNimi().toString();
        return s;
    }
    
    
    /**
     * Palauttaa kellonajan
     * @return kellonajan
     */
    public String getKello() {
        return this.kellonaika;
    }
    
    
    /**
     * @param h huone
     */
    public void lisaaHuone(Huone h) {
        huone = h;
    }
    
    
    /**
     * Luodaan yksittäinen merkintä
     */
    public TehtavaLoki() {
        kellonaika = getTime();
        kayttaja = getKayttaja();
        huone = getHuone();
        tehtava = getTehtava();
    }
    
    
    /**
     * Luodaan yksittäinen merkintä
     * @param k kayttaja
     * @param h huone
     * @param t tehtavat
     * @param kellonaika  kellonaika
     */
    public TehtavaLoki(Kayttaja k , Huone h, Tehtava t, String kellonaika) {
        this.kellonaika = kellonaika;
        this.kayttaja = k;
        this.huone = h;
        this.tehtava = t ; 
    }
    
    
    /**
     * Luodaan yksittäinen merkintä
     * @param k kayttaja
     * @param h huone
     * @param t tehtavat
     */
    public TehtavaLoki(Kayttaja k , Huone h, Tehtava t) {
        this.kellonaika = getTime();
        this.kayttaja = k;
        this.huone = h;
        this.tehtava = t ; 
    }

    
    /**
     * Hakee tiedon valitusta käyttäjästä
     * @return valittu käyttäjä
     */
    public Kayttaja getKayttaja() {
        return kayttaja;
    }
    
    
    /**
     * Palauttaa huoneen id:N
     * @return huone id
     */
    public int  getHuoneId() {
        return huone.getId();
    }
    
    
    /**
     * palauttaa huoneen id:N
     * @return tehtava id;
     */
    public int  getTehtavaId() {
        return tehtava.getId();
    }
    
    
    /**
     * palautta kellonajan
     * @return kellonaika;
     */
    public String  getKellonaika() {
        return kellonaika;
    }
    
    
    /**
     * hakee kayttajan id:N
     * @return id:n
     */
    public int getKayttajaId() {
        return kayttaja.getId();
    }
    
    
    /**
     * hakee huoneen
     * @return valittu huone
     */
    public Huone getHuone() {
        return huone;
    }
    
    
    /**
     * hakee tehtävän
     * @return valittu tehtävä
     */
    public Tehtava getTehtava() {
        return tehtava;
    }
    
    
    /**
     * @param out tietovirta
     * 
     */
    public void tulosta(PrintStream out) {
        out.println(kellonaika + " " + kayttaja.getNimi()+ " " + huone.getNimi() + " "+ tehtava.getNimi());
    
    }
    
    
    /**
     * @param huone huone
     */
    public void setHuone(String huone) {
       Huone h = new Huone(huone);
       this.huone = h;
    }
    
    
    /**
     * @param args ei käytössä
     */
    public static void main(String[] args) {
        TehtavaLoki suoritus = new TehtavaLoki();
        suoritus.tulosta(System.out);
    }

    
    /**
     * @param tehtava1 tht
     */
    public void lisaaTehtava(Tehtava tehtava1) {
        this.tehtava = tehtava1;
        tehtavalkm++;
    }

    
    /**
     * @param kayttaja2 äijä
     */
    public void lisaaKayttaja(Kayttaja kayttaja2) {
        kayttaja = kayttaja2;     
    }   
}