package htScene;


import fi.jyu.mit.fxgui.ComboBoxChooser;
import fi.jyu.mit.fxgui.ModalController;
import htLuokat.Kayttaja;
import htLuokat.KotityoRekisteri;
import htLuokat.SailoException;
import htLuokat.TehtavaLoki;
import htLuokat.TehtavaLokit;
import javafx.fxml.FXML;
import javafx.fxml.FXMLLoader;
import javafx.scene.Parent;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.layout.BorderPane;
import javafx.stage.Stage;

/**
 * Etusivun ohjain
 *  @author Leevi Pohja(pohjalma@jyu.fi), Jaakko Juvonen(jtjuvone@jyu.fi)
 *  , Jaakko Jokisalo(jjjokisa@student.jyu.fi)
 * @version 15 Feb 2022
 *
 */
public class EtusivuController{
    
    @FXML private BorderPane etusivu;
    
    @FXML private ComboBoxChooser<Kayttaja> kayttajaChoice;
    
    @FXML private Button ok;
    
    @FXML private void handleAvaa(){
        handleOk();
        }
    
    
    private static TehtavaLokit tehtavaloki = new TehtavaLokit();
    KotityoRekisteri rekisteri  = new KotityoRekisteri();
    KotityoGUIController paasivu;
    

    /**
     * Lisataan kayttajat
     */
    public void kayttajalisays() {
        for(int i = 0; i < rekisteri.kayttajienLkm(); i++) {
        kayttajaChoice.add(rekisteri.getjasen(i));
        }
    }
    
    
    /**
     * @param rekisteri rekisteri
     */
    public void setRekisteri(KotityoRekisteri rekisteri) {
        this.rekisteri = rekisteri;
        
    }

    
    /**
     * @param suoritus suoritus
     */
    public static void lisaa(TehtavaLoki suoritus) {
      try {
        tehtavaloki.lisaa(suoritus);
    } catch (SailoException e) {
        e.printStackTrace();
    }
    }
    
    
    /**
     * @param loki loki jota käytetään tässä käyttöliittymässä
     */
    public void setLoki(TehtavaLokit loki) {
        EtusivuController.tehtavaloki = loki;
    }
    
    
/**
 * Ok nappia painettaessa etusivulla avaisi pääikkunan 
 */
   private void handleOk() {
       try {
       FXMLLoader fxmlLoader = new FXMLLoader(getClass().getResource("KotityoGUIView.fxml"));
       Parent root1 = (Parent) fxmlLoader.load();
       Stage stage = new Stage();
       stage.setScene(new Scene(root1));
       stage.show();
       KotityoGUIController paasivu1 = (KotityoGUIController)fxmlLoader.getController();
       paasivu1.setrekisteri(rekisteri);

       paasivu1.vieViite();
      
       Kayttaja valittu = kayttajaChoice.getSelectedObject();
       if(valittu != null) paasivu1.setKayttaja(valittu);
       
       ModalController.closeStage(etusivu);
       } catch (Exception e) {
              System.err.println(e.getMessage()); 
               }  
    }
}

    


