package htScene;

import fi.jyu.mit.fxgui.ListChooser;
import fi.jyu.mit.fxgui.ModalController;
import htLuokat.Kayttaja;
import htLuokat.KotityoRekisteri;
import javafx.fxml.FXML;
import javafx.scene.control.Button;
import javafx.scene.control.TextField;
import javafx.scene.layout.Pane;

/**
 *  @author Leevi Pohja(pohjalma@jyu.fi), Jaakko Juvonen(jtjuvone@jyu.fi)
 *  , Jaakko Jokisalo(jjjokisa@student.jyu.fi)
 * @version 9 Mar 2022
 *
 */


public class KayttajaController {
    KotityoRekisteri rekisteri = new KotityoRekisteri();
    private boolean uusi = true;
    private ListChooser<Object> kohdeValitsin; 
    private Kayttaja kasiteltava;
    KotityoGUIController sivu;
    
    
   /**
    * Alla FXML objekteja
    *  
    */
    
    @FXML
    private Pane lisaaKayttaja;
    
    @FXML
    private Button eiku;

    @FXML
    private TextField nimitext;

    @FXML
    private Button ok;

    @FXML
    void handleEiku() {
       handlePeruutus();
    }

    @FXML
    void handleOk() {
       handleTallennus();
    }

    
    /**
     * Handlen peruutus
     */
    private void handlePeruutus() {

        ModalController.closeStage(lisaaKayttaja);
    }
    
    

/**
 * Handlen tallennus
 */
    private void handleTallennus() {
        if(uusi == false) {
            
            handleMuokkaus();

        }
        else {
            String nimi = nimitext.getText(); 
            if(nimi == null) return;
            Kayttaja uusi1 = new Kayttaja(nimi.trim());
            rekisteri.lisaaKayttaja(uusi1);
        }

        rekisteri.tallenna("kayttajat.dat");
        ModalController.closeStage(lisaaKayttaja);     
        hae();
    }
    

    /**
     * Kasitellaan muokkauksessa tapahtuneet muutokset
     */
    public void handleMuokkaus() {
        String nimi = nimitext.getText();
        rekisteri.muokkaa(nimi.trim(), kasiteltava, "Kayttaja");
       
        sivu.alusta();
    }
    
    
    /**
     *  Hakee käyttäjän
     */
    public void hae() {
        kohdeValitsin.clear();
        for(int i = 0; i < rekisteri.kayttajienLkm(); i++)
        {
            Kayttaja lisattava = rekisteri.haeKayttaja(i);
            kohdeValitsin.add(lisattava.getNimi(), lisattava);
        }
        
    }
    
    
    /**
     * @param rekisteri rekisteri
     */
    public void setrekisteri(KotityoRekisteri rekisteri) {
        this.rekisteri = rekisteri; 
    }

    
    /**
     * @param kohdeValitsin2 listchooser
     */
    public void setValitsin( ListChooser<Object> kohdeValitsin2 ) {
       
        this.kohdeValitsin = kohdeValitsin2;
    }
   
    
    /**
     * Muutetaan arvo, jotta tiedetään ollaanko lisäämässä uutta vai muokkaavassa olemassaolevaa
     * @param arvo muutetaan falseksi jos muokataan
     */
    public void setUusi(boolean arvo) {
        this.uusi = arvo;
    }
    
    
    /**
     * Asetetaan valittu kayttaja
     * @param k asetettava kayttaja
     */
    public void setKasiteltava(Kayttaja k) {
        this.kasiteltava = k;
    }
    
    
    /**
     * Asetetaan nimi kayttajan nahtavaksi
     * @param s nimi
     */
    public void setNimi(String s ) {
        nimitext.setText(s);
    }
     
    
    /**
     * @param controller controller
     */
    public void setViite(KotityoGUIController controller) {
        sivu = controller;
    } 
}
