package htScene;

import htLuokat.KotityoRekisteri;
import javafx.application.Application;
import javafx.stage.Stage;
import javafx.scene.Scene;
import javafx.scene.layout.Pane;
import javafx.fxml.FXMLLoader;


/**
 *  @author Leevi Pohja(pohjalma@jyu.fi), Jaakko Juvonen(jtjuvone@jyu.fi)
 *  , Jaakko Jokisalo(jjjokisa@student.jyu.fi)
 * @version 31.1.2022
 *
 */


public class KotityoMain extends Application {
    @Override
    public void start(Stage primaryStage) {
        try {
            FXMLLoader ldr = new FXMLLoader(getClass().getResource("etusivuView.fxml")); 
            
            final Pane root = ldr.load();
            final EtusivuController kotityoCtrlT = (EtusivuController)ldr.getController();
            
            Scene scene = new Scene(root);
            scene.getStylesheets().add(getClass().getResource("kotityo.css").toExternalForm());
            
            primaryStage.setScene(scene);
            primaryStage.setTitle("kotityo");
            
           KotityoRekisteri rekisteri = new KotityoRekisteri();
           kotityoCtrlT.setRekisteri(rekisteri);
           
           rekisteri.lue("kayttajat.dat");
           rekisteri.lue("huoneet.dat");
           rekisteri.lue("tehtavat.dat");
           rekisteri.lue("liimataulu.dat");
           rekisteri.lue("tehtavalog.dat");
           
           kotityoCtrlT.setLoki(rekisteri.getLoki());
           kotityoCtrlT.kayttajalisays(); 
           
            primaryStage.show();
   
        } catch(Exception e) {
            e.printStackTrace();
        }
    }

    
    /**
     * @param args Ei käytössä
     */
    public static void main(String[] args) {
        launch(args);
    }
}