package htScene;
import java.io.PrintStream;
import fi.jyu.mit.fxgui.ComboBoxChooser;
import fi.jyu.mit.fxgui.ModalController;
import fi.jyu.mit.fxgui.StringGrid;
import fi.jyu.mit.fxgui.TextAreaOutputStream;
import htLuokat.Huone;
import htLuokat.Kayttaja;
import htLuokat.KotityoRekisteri;
import htLuokat.Tehtava;
import htLuokat.TehtavaLoki;
import javafx.fxml.FXML;
import javafx.scene.control.ScrollPane;
import javafx.scene.control.TextArea;
import javafx.scene.layout.Pane;
import javafx.scene.text.Font;

/**
 *  @author Leevi Pohja(pohjalma@jyu.fi), Jaakko Juvonen(jtjuvone@jyu.fi)
 *  , Jaakko Jokisalo(jjjokisa@student.jyu.fi)
 * @version 31.1.2022
 *
 */


public class SuoritusController {

    KotityoRekisteri rekisteri = new KotityoRekisteri();
     private ScrollPane panelSuoritus = new ScrollPane();
     @FXML private ComboBoxChooser<Huone> siivousalue;
     @FXML private ComboBoxChooser<Tehtava> valittutehtava;
     @FXML private Pane suoritus;

    @FXML
    void handlePeruuta() {
     peruuta();
    }

    @FXML
    void handleSuorita() {
        if(valittutehtava.getSelectedObject() == null || siivousalue.getSelectedObject() == null) return;
        suorita();
    }
    
   
    // ==========================
    
   private StringGrid<TehtavaLoki> suoritusIkkuna = new StringGrid<>();
   private  TextArea tulostusview = new TextArea();
   private Kayttaja valittu;
    
   
    /**
     * @param rekisteri rekisteri
     */
    public void setrekisteri(KotityoRekisteri rekisteri) {
        this.rekisteri = rekisteri;
    }
    
    
    /**
     * Peruutta suorituksen
     */
    private void peruuta() {
        
        ModalController.closeStage(suoritus);
    }
    
    
    /**
     * Hakee huoneet ikkunaan
     */
    public void haehuoneet() {
        for (int i = 0; i < rekisteri.huoneetlkm(); i++) {
            siivousalue.add(rekisteri.getHuone(i));
        }     
    }
    
    
    /**
     * Hakee tehtavat ikkunaan
     */
    public void haetehtavat() {
        valittutehtava.clear();
        Huone h =  siivousalue.getSelectedObject();
        if (h == null) return;
        for (int i = 0; i < rekisteri.tehtavatlkm(); i++) {
            Tehtava t = rekisteri.getTehtava(i);
            if(rekisteri.onkoKaytossa(h.getId(), t.getId()))valittutehtava.add(t);
        }
    }
    
    
    /**
     * Tekee suorituksen
     */
    private void suorita(){
        if(valittu == null) return;
       TehtavaLoki uusi = new TehtavaLoki(valittu, siivousalue.getSelectedObject(),valittutehtava.getSelectedObject());
       rekisteri.lisaa(uusi);
       rekisteri.tallenna("tehtavalog.dat"); 
       suoritusIkkuna.add(uusi.getKayttaja().toString(),uusi.getHuone().toString(),uusi.getTehtava().toString(), uusi.getKello() );
       ModalController.closeStage(suoritus);
    }
    
    
    /**
     * Alustaa
     */
    public void alusta() {
        panelSuoritus.setContent(tulostusview);
        tulostusview.setFont(new Font("Courier New", 12));
        panelSuoritus.setFitToHeight(true);
    }
    
    
    /**
     * @param kayttaja = valittu kayttaja
     */
    public void setKayttaja(Kayttaja kayttaja) {
        valittu = kayttaja;
    }

    
    /**
     * @param suoritus1 joka tulostetaan
     */
    public  void tulosta(TehtavaLoki suoritus1) {
               tulostusview.setText("");
                try (PrintStream os = TextAreaOutputStream.getTextPrintStream(tulostusview)) {
                     suoritus1.tulosta(os);
                } catch (Exception e) {
                    System.err.println(e.getMessage()); 
                    }     
    }

    
    /**
     * @param panelSuoritus panel 
     * @param tulostusview tulostus
     */
    public void setTulostus(ScrollPane panelSuoritus,  TextArea tulostusview) {
        this.tulostusview = tulostusview;
        this.panelSuoritus = panelSuoritus;     
    }

    
    /**
     * Asetetaan ikkuna jotta voidaan tulostaa siihen
     * @param suoritusIkkuna stringgrid viite
     */
    public void setTulostusalue(StringGrid<TehtavaLoki> suoritusIkkuna) {
        
        this.suoritusIkkuna = suoritusIkkuna;
    }   
}

   
   

