package htScene;

import java.net.URL;
import java.util.ResourceBundle;
import fi.jyu.mit.fxgui.Dialogs;
import fi.jyu.mit.fxgui.ListChooser;
import fi.jyu.mit.fxgui.ModalController;
import htLuokat.Huone;
import htLuokat.Kayttaja;
import htLuokat.KotityoRekisteri;
import htLuokat.Tehtava;
import javafx.fxml.FXML;
import javafx.fxml.FXMLLoader;
import javafx.fxml.Initializable;
import javafx.scene.Parent;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.control.Label;
import javafx.scene.control.RadioButton;
import javafx.scene.control.TextField;
import javafx.scene.control.ToggleGroup;
import javafx.scene.layout.Pane;
import javafx.stage.Stage;
/**
 *  @author Leevi Pohja(pohjalma@jyu.fi), Jaakko Juvonen(jtjuvone@jyu.fi)
 *  , Jaakko Jokisalo(jjjokisa@student.jyu.fi)
 * @version 16 Feb 2022
 *
 */


public class muokkaaController  implements Initializable{
    KotityoRekisteri rekisteri = new KotityoRekisteri();
    muokkaaNextController huoneTehtava = new muokkaaNextController();
    KayttajaController kikkuna;
    KotityoGUIController sivu;

    private String id;
    
    
 /**
 * Alla FXML objekteja
 */
    @FXML private ListChooser<Object> kohdeValitsin; 

    @FXML private Pane muokkaussivuNext;
    
    @FXML private Label labelValittu;
    
    @FXML private RadioButton rbHuone;

    @FXML private RadioButton rbKayttaja;

    @FXML private RadioButton rbTehtava;
    
    @FXML private ToggleGroup kohdeGroup;
    
    @FXML private Button cancelNext;

    @FXML private Button lisaaKayttoon;

    @FXML private TextField nimiText;

    @FXML private Button okTallenna;   

    @FXML private Button poistaKaytto;

    @FXML void handleCancelNext() {
        ModalController.closeStage(muokkaussivuNext);
    }

    @FXML void handleTallenna() {
        Dialogs.showMessageDialog("Tässä kohtaa tallenetaan suoritus(ei osata vielä)");
        ModalController.closeStage(muokkaussivuNext);
    }
    
    @FXML private Button lisaaButton;

    @FXML private Button muokkaaButton;

    @FXML private Button poista;

    @FXML void handleLisaa() {
        lisaa();
    }

    @FXML void handleNextMuokkaa() {
        kohdeMuokkaus();
        sivu.alusta();
    }

    @FXML
    void handlePoista() {
        poista();
        sivu.alusta();
    }

    
    /**
     * Lisää käyttäjän
     */
    private void lisaa() {
        if (id.equals("Käyttäjä")) uusiKayttaja();
        else
        try {
            FXMLLoader fxmlLoader = new FXMLLoader(getClass().getResource("muokkausnext.fxml"));
            Parent root1 = (Parent) fxmlLoader.load();
            Stage stage = new Stage();
            stage.setScene(new Scene(root1));
            stage.show();    
            
            huoneTehtava = (muokkaaNextController)fxmlLoader.getController();
            huoneTehtava.setRekisteri(rekisteri, id);
            huoneTehtava.setValitsin(kohdeValitsin);
            huoneTehtava.haeIkkuna();
            huoneTehtava.setViite(sivu);          

            } catch (Exception e) {
                   System.err.println(e.getMessage()); 
             
                }
    }
    
    
    /**
     * Poistaa valitun objektin
     */
    private void poista() {
        Object poistettava = kohdeValitsin.getSelectedObject();
        if(poistettava == null) return;
        if(! Dialogs.showQuestionDialog( "Varoitus: muutosta ei voi peruuttaa", "Poistetaanko: " + poistettava, "Kyllä","eiku") ) return;
        if (id.equals("Käyttäjä")) rekisteri.poista(poistettava, 1);
        if(id.equals("Tehtävä")) rekisteri.poista(poistettava, 2);;
        if(id.equals("Huone")) rekisteri.poista(poistettava, 3);
        if(id.equals("Tehtävä")) haeTehtavat();
        if(id.equals("Huone")) haeHuoneet();
        if(id.equals("Käyttäjä")) haeKayttajat();
       return;

    } 
         
    
    /**
     * @param location paikka
     * @param resources resurssi
     */
    @Override
    public void initialize(URL location, ResourceBundle resources) {
        kohdeGroup.selectedToggleProperty().addListener( (e) -> nayta());
        
        labelValittu.setText("");
    }
    
    
    /**
     * Näyttää tehtävät, huoneet tai käyttäjät
     */
    private void nayta() {
        RadioButton rb = (RadioButton)kohdeGroup.getSelectedToggle();
        if ( rb == null ) return;
        labelValittu.setText("Valittu: " + rb.getText());
        id = rb.getText();
       
        if(id.equals("Tehtävä")) haeTehtavat();
        if(id.equals("Huone")) haeHuoneet();
        if(id.equals("Käyttäjä")) haeKayttajat();
    }
    
    
 /**
  * Hakee tehtävät
  */
    private void haeTehtavat() {
        kohdeValitsin.clear();
        
        for(int i = 0; i < rekisteri.tehtavatlkm(); i++)
        {
            Tehtava lisattava = rekisteri.getTehtava(i);
            kohdeValitsin.add(lisattava.getTehtavaNimi(), lisattava);
        }
        
    }

    
    /**
     * Hakee huoneet
     */
    private void haeHuoneet() {
        kohdeValitsin.clear();
        for(int i = 0; i < rekisteri.huoneetlkm(); i++)
        {
             Huone lisattava = rekisteri.getHuone(i);
             
            kohdeValitsin.add(lisattava.getNimi(), lisattava);
        }
        
    }

    
    /**
     * Hakee käyttäjät
     */
    private void haeKayttajat() {
        kohdeValitsin.clear();
        for(int i = 0; i < rekisteri.kayttajienLkm(); i++)
        {
            Kayttaja lisattava = rekisteri.haeKayttaja(i);
            kohdeValitsin.add(lisattava.getNimi(), lisattava);
        }

    }
    

    /**
     * Muokkaa valittua kohdetta
     */
    private void kohdeMuokkaus() { 
        
         if (id == null) return;
         if (id.equals("Käyttäjä")) kayttajaMuokkaus();
         else {
        try {
           avaaHTM();

            } catch (Exception e) {
                   System.err.println(e.getMessage()); 
             
                }
             
                } 
         sivu.alusta();
    }
    
    
    /**
     * Avaa tehtävän j ahuoneen muokkausikkunan ja vie kaikki tarvittavat tiedot eteenpäin
     */
    private void avaaHTM() {
        
        try {
            Object o = kohdeValitsin.getSelectedObject();
            if(o != null) {
        
            FXMLLoader fxmlLoader = new FXMLLoader(getClass().getResource("muokkausnext.fxml"));
            Parent root1 = (Parent) fxmlLoader.load();
            Stage stage = new Stage();
            stage.setScene(new Scene(root1));
            stage.show();
           
            
            huoneTehtava = (muokkaaNextController)fxmlLoader.getController();
            huoneTehtava.setRekisteri(rekisteri, id);
            huoneTehtava.setValitsin(kohdeValitsin);
            huoneTehtava.muokkaus(false);
            huoneTehtava.setValittu(o);
            huoneTehtava.setViite(sivu);
            sivu.alusta();
            
            if((id.equals("Huone"))) {
                Huone h = (Huone) o;
                huoneTehtava.setNimiJatehtavat(h.getNimi());
                huoneTehtava.setLuokka(1);
                sivu.alusta();
                }
            else {
                Tehtava t = (Tehtava) o;
                huoneTehtava.setNimiJaHuoneet(t.getNimi());
                huoneTehtava.setLuokka(2);
                sivu.alusta();
                }

            }
            sivu.alusta();

            } catch (Exception e) {
                   System.err.println(e.getMessage());
            }        
    }
    
    
    /**
     * Muokkaa käyttäjää
     */
    private void kayttajaMuokkaus() {
        try {
            Object o = kohdeValitsin.getSelectedObject();
            if(o != null) {
            
            FXMLLoader fxmlLoader = new FXMLLoader(getClass().getResource("muokkauskayttaja.fxml"));
            Parent root1 = (Parent) fxmlLoader.load();
            Stage stage = new Stage();
            stage.setScene(new Scene(root1));
            stage.show();
            
            Kayttaja kasiteltava = (Kayttaja) o;
            kikkuna = (KayttajaController)fxmlLoader.getController();
            kikkuna.setrekisteri(rekisteri);
            kikkuna.setValitsin(kohdeValitsin);
            kikkuna.setKasiteltava(kasiteltava);
            kikkuna.setUusi(false);
            kikkuna.setNimi(kasiteltava.getNimi());
            kikkuna.setViite(sivu);
            sivu.alusta();      
         
            }

            } catch (Exception e) {
                   System.err.println(e.getMessage());
            }
    }
        
    
    
    /**
     * Uusi käyttäjä
     */
    private void uusiKayttaja() {
        
        try {
            FXMLLoader fxmlLoader = new FXMLLoader(getClass().getResource("muokkauskayttaja.fxml"));
            Parent root1 = (Parent) fxmlLoader.load();
            Stage stage = new Stage();
            stage.setScene(new Scene(root1));
            stage.show();
            
            kikkuna = (KayttajaController)fxmlLoader.getController();
            kikkuna.setrekisteri(rekisteri);
            kikkuna.setValitsin(kohdeValitsin);

            } catch (Exception e) {
                   System.err.println(e.getMessage());     
            }    
    }
    

    /**
     * @param rekisteri rekisteri
     * 
     */
    public void setrekisteri(KotityoRekisteri rekisteri) {
        this.rekisteri = rekisteri;
    }
    
    
    /**
     * vie viitteen
     * @param controller kontrolleri
     */
    public void vieViite(KotityoGUIController controller) {
        sivu = controller;
    }
}
