package htScene;
import java.util.ArrayList;
import fi.jyu.mit.fxgui.ListChooser;
import fi.jyu.mit.fxgui.ModalController;
import htLuokat.Huone;
import htLuokat.KotityoRekisteri;
import htLuokat.Tehtava;
import javafx.fxml.FXML;
import javafx.scene.control.Button;
import javafx.scene.control.TextField;
import javafx.scene.layout.Pane;

/**
 *  @author Leevi Pohja(pohjalma@jyu.fi), Jaakko Juvonen(jtjuvone@jyu.fi)
 *  , Jaakko Jokisalo(jjjokisa@student.jyu.fi)
 * @version 17 Feb 2022
 *
 */


public class muokkaaNextController {
    
    
    @FXML private Pane muokkaussivuNext;
    
    private KotityoGUIController sivu;
    
    @FXML void handleCancelNext() {
        ModalController.closeStage(muokkaussivuNext);        
        System.out.println("lenny");
    }

    @FXML void handleLisaaKayttoon() {
        if(uusi == true) valmistelu();
        else

            aktivoi();
    }

    @FXML void handlePoistaKaytosta() {
        if(uusi == true) valmisteluP();
        else
        deaktivoi();
    }
    
    @FXML private Button cancelNext;
    
    @FXML private Button poistaKaytto;
    
    @FXML private Button lisaaKayttoon;
    
    @FXML private TextField nimiText;
    
    @FXML void nimiReleased() {
        //todo
    }
    
    @FXML private Button okTallenna;
    
    @FXML void handleTallenna() {

        tallennus();
    }
    
    @FXML private ListChooser<Object> eiKaytossa;

    @FXML private ListChooser<Object> kaytossa;
    

    /**
     * @param controller controller
     */
    public void setViite(KotityoGUIController controller) {
        sivu = controller;
    }
 
    
    /**
     * Otetaan tehtävä käyttöön valitulle huoneelle
     */
    public void aktivoi() {
       if(eiKaytossa.getSelectedObject() == null) return;
     Object olio =  eiKaytossa.getSelectedObject();
     if(olio == null) return;
     if(kasiteltava == null) return;
     Tehtava t;
     Huone h;
     if(id.equals("Huone")) {
          t = (Tehtava) olio;
          h = (Huone)kasiteltava; 
     }
     else {
         t =(Tehtava) kasiteltava;
         h = (Huone) olio;
     }
     rekisteri.lisaaLiimatauluun(h, t);
     rekisteri.tallenna("liimataulu.dat");
    if(id.equals("Huone")) haeTehtavat();
    else haeHuoneet();
    
    sivu.alusta();
    }
    
    
    /**
     * Otetaan tehtävä pois käytöstä valitulta huoneelta
     */
    public void deaktivoi() {      
        if(kaytossa.getSelectedObject() == null) return;
        Object olio =  kaytossa.getSelectedObject();
        if(olio == null) return;
        if(kasiteltava == null) return;
        Tehtava t;
        Huone h;
        
        
        if(id.equals("Huone")) {
            t = (Tehtava) olio;
            h = (Huone)kasiteltava; 
       }
       else {
           t =(Tehtava) kasiteltava;
           h = (Huone) olio;
       }
        rekisteri.poistaliimataulusta(h.getId(), t.getId());
        rekisteri.tallenna("liimataulu.dat");
        if(id.equals("Huone")) haeTehtavat();
        else haeHuoneet();
        sivu.alusta();
    }
    
    
    /**
     * Valmistelee, jos otetaan käyttöön
     */
    private void valmistelu() {
        if(eiKaytossa.getSelectedObject() == null) return;         
        Object olio = eiKaytossa.getSelectedObject();
        if(olio == null) return;
         lisattavat.add(olio);
        if(id.equals("Huone")) paivitaT();
        else paivitaH();        
    }
    
    
    /**
     * Valmistelee, jos poistetaan käytöstä
     */
    private void valmisteluP() {
        if(kaytossa.getSelectedObject() == null) return;
        Object olio = kaytossa.getSelectedObject();
        if(olio == null) return;
        if(lisattavat.contains(olio))lisattavat.remove(olio);
        if(id.equals("Huone")) paivitaT();
        else paivitaH();   
    }
    
    
    /**
     * Päivittää huoneet
     */
    public void paivitaH() {
        kaytossa.clear();
        eiKaytossa.clear();
        for(int i = 0; i < rekisteri.huoneetlkm(); i++) {
        if(lisattavat.contains(rekisteri.getHuone(i)))
         {
            kaytossa.add(rekisteri.getHuone(i));
         }
         else {
             eiKaytossa.add(rekisteri.getHuone(i));
         }
        }
    }
    
    
    /**
     * Päivitetään käytettävät
     */
    public void paivitaT() {
        kaytossa.clear();
        eiKaytossa.clear();
        for(int i = 0; i < rekisteri.tehtavatlkm(); i++) {
        if(lisattavat.contains(rekisteri.getTehtava(i)))
         {
            kaytossa.add(rekisteri.getTehtava(i));
         }
         else {
             eiKaytossa.add(rekisteri.getTehtava(i));
         }
        }
    }
    
    
    /**
     * Lisätään ei käytössä ja käytössa olevat näkyviin
     */
    public void haeIkkuna(){
        eiKaytossa.clear();
       if(id.equals("Huone")) {
       for(int i = 0; i < rekisteri.tehtavatlkm(); i++) {
           eiKaytossa.add(rekisteri.getTehtava(i));
       }
       }
        else {
            for(int i = 0; i < rekisteri.huoneetlkm(); i++) {
                eiKaytossa.add(rekisteri.getHuone(i));
            }
        }
    }
    

    /**
     * Hakee huoneet
     */
    private void haeHuoneet() {
        eiKaytossa.clear();
        kaytossa.clear();
        Tehtava t = (Tehtava) kasiteltava;
        for(int i = 0; i < rekisteri.huoneetlkm(); i++) {
            Huone lisattava = rekisteri.getHuone(i);
            if(!rekisteri.onkoKaytossa(lisattava.getId(), t.getId())) {
            eiKaytossa.add(lisattava.getNimi(), lisattava);
            }
            else {
                kaytossa.add(lisattava.getNimi(), lisattava);
            }
        }
    }
    
    
    /**
     * Hakee tehtävät
     */
    private void haeTehtavat() {
        eiKaytossa.clear();
        kaytossa.clear();
        Huone h = (Huone) kasiteltava;
        for(int i = 0; i < rekisteri.tehtavatlkm(); i++)
        {
            Tehtava lisattava = rekisteri.getTehtava(i);
           if(!rekisteri.onkoKaytossa(h.getId(), lisattava.getId())) {
            eiKaytossa.add(lisattava.getTehtavaNimi(), lisattava);
           }
           else{
               kaytossa.add(lisattava.getTehtavaNimi(), lisattava);
           }
        }              
    }


    /**
     * Hakee tehtävän
     */
    private void haeTehtava() {
        
        kohdeValitsin.clear();
        
        for(int i = 0; i < rekisteri.tehtavatlkm(); i++)
        {
            Tehtava lisattava = rekisteri.getTehtava(i);
            kohdeValitsin.add(lisattava.getTehtavaNimi(), lisattava);
        }  
    }

    //========================================================
    boolean uusi = true;
  private Object kasiteltava;
  private int luokka = 0; 
    KotityoRekisteri rekisteri = new KotityoRekisteri();
    private ListChooser<Object> kohdeValitsin;
    
    private String id;
    private ArrayList<Object> lisattavat= new ArrayList<Object>();
 

    /**
     * Hakee huoneen
     */
    public void haeHuone() {
        kohdeValitsin.clear();
        for(int i = 0; i < rekisteri.huoneetlkm(); i++)
        {
             Huone lisattava = rekisteri.getHuone(i);
             
            kohdeValitsin.add(lisattava.getNimi(), lisattava);
        }
      
        
    }
    
    
    /**
     * Ohjelma joka hoitaa huoneen muutoksen ja välittää muokkauspyynnön rekisterille
     */
    public void muokkaaH() {
      
            Huone h = (Huone) kasiteltava;
           
          String nimi = nimiText.getText();
          if (h.getNimi() != nimi )
            rekisteri.muokkaa(nimi, h, "Huone");
    }
    
    
    /**
     * Tämä hoitaa thetavn muokkaamisen eli pyynnön ja tietojen välittämisen rekisterille.
     */
    public void muokkaaT() {
        Tehtava t = (Tehtava) kasiteltava;
        String nimi = nimiText.getText();
        if(t.getNimi() != nimi)
        rekisteri.muokkaa(nimi, t, "Tehtava");
    }
    
    
    /**
     * Asettaa käyttöliittymään nimen näkyväksi
     * @param nimi nimi joka asetetaan käyttäjälle näkyväksi
     */
    public void setNimiJaHuoneet(String nimi) {
        nimiText.setText(nimi);
        haeHuoneet();
    }
    
    
    /**
     * Asettaa käyttöliittymään nimen näkyväksi
     * @param nimi nimi joka asetetaan käyttäjälle näkyväksi
     */
    public void setNimiJatehtavat(String nimi) {
        nimiText.setText(nimi);
       haeTehtavat(); 
    }
    
    
    /**
     * Täällä hoidetaan uusien huoneiden ja tehtävien lisäys ja muokkauspyynnöt ja viedään 
     * tarvittavat tiedot oikeille ohjelmille 
     */
    public void tallennus() {
       if(uusi == false) {
          if(luokka == 1) { muokkaaH();
          haeHuone();
          rekisteri.tallenna("huoneet.dat");
          uusi = true;
          }
          else {
              if(luokka == 2) muokkaaT();
              haeTehtava();
              rekisteri.tallenna("tehtavat.dat");
              uusi = true;
          }
       }

       else {
        if (id.equals("Huone")) {
            lisaaHuone();
            haeHuone();}
        else {
        lisaaTehtava();
        haeTehtava();
        }
        uusi = false;
    }
        sivu.alusta();
        ModalController.closeStage(muokkaussivuNext);
    }
    
    
    /**
     * Asetetaan listchooser
     * @param kohdeValitsin2 listchooser
     */
    public void setValitsin( ListChooser<Object> kohdeValitsin2 ) {
       
        this.kohdeValitsin = kohdeValitsin2;
    }
    
    
    /**
     * Lisää tehtävän
     */
    private void lisaaTehtava() {
    String nimi = nimiText.getText();
    Tehtava tehtava = new Tehtava(nimi.trim());
    rekisteri.lisaaTehtava(tehtava);
    
    for(int i = 0; i < lisattavat.size(); i++) {
        Huone t = (Huone) lisattavat.get(i);
        rekisteri.lisaaLiimatauluun(t, tehtava);
    }
    rekisteri.tallenna("tehtavat.dat");
    rekisteri.tallenna("liimataulu.dat");
    lisattavat.clear();
    }
    

    /**
     * Asetetaan valittu olio kasiteltava atribuuttiin
     * @param kasiteltava kasiteltava olio
     */
    public void setValittu(Object kasiteltava) {
        this.kasiteltava = kasiteltava;
    }
    
    
    /**
     * Asetetaan totuusarvo että tiedetään että käsitellään muokkausta
     * @param muokkaus totuusarvo true siitä että käsitellään muokkausta
     */
    public void muokkaus(boolean muokkaus) {
        uusi = muokkaus;
    }
    
    
    /**
     * Asetetaan luokka jotta tiedetään minkä luokan oliota käsitellään
     * @param luokka numero joka edustaa luokkaa
     */
    public void setLuokka(int luokka) {
        this.luokka = luokka;
    }
    
    
    /**
     * Lisää huoneen
     */
    private void lisaaHuone() {
        String nimi = nimiText.getText();
        Huone huone = new Huone(nimi.trim());
 
        rekisteri.lisaaHuone(huone);
        rekisteri.tallenna("huoneet.dat");
        
        for(int i = 0; i < lisattavat.size(); i++) {
            Tehtava t = (Tehtava) lisattavat.get(i);
            rekisteri.lisaaLiimatauluun(huone, t);
        }
        rekisteri.tallenna("liimataulu.dat");
        lisattavat.clear();
    }
    
    
    /**
     * @param rekisteri rekisteri
     * @param id id
     */
    public void setRekisteri(KotityoRekisteri rekisteri, String id) {
        this.rekisteri = rekisteri;
        this.id = id;
    }
}
